package snap.chat.id;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "snap.chat.id", "snap.chat.id.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "snap.chat.id", "snap.chat.id.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "snap.chat.id.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.PanelWrapper _pcamera = null;
public static int _v7 = 0;
public anywheresoftware.b4a.objects.PanelWrapper _pright = null;
public static float _v0 = 0f;
public static float _vv1 = 0f;
public static float _vv2 = 0f;
public static float _vv3 = 0f;
public anywheresoftware.b4a.objects.PanelWrapper _pleft = null;
public anywheresoftware.b4a.objects.PanelWrapper _pdown = null;
public anywheresoftware.b4a.objects.PanelWrapper _pup = null;
public static boolean _v5 = false;
public static String _v6 = "";
public snap.chat.id.starter _vv4 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 29;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 30;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 257;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
 //BA.debugLineNum = 259;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 //BA.debugLineNum = 261;BA.debugLine="If LockMove Then";
if (_v5) { 
 //BA.debugLineNum = 262;BA.debugLine="If MoveDirection = \"left\" Then";
if ((mostCurrent._v6).equals("left")) { 
 //BA.debugLineNum = 263;BA.debugLine="pRight.SetLayoutAnimated(500,pCamera.Left + pC";
mostCurrent._pright.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()+mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 264;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 265;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 266;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else if((mostCurrent._v6).equals("right")) { 
 //BA.debugLineNum = 268;BA.debugLine="pLeft.SetLayoutAnimated(500,pCamera.Left - pCa";
mostCurrent._pleft.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()-mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 269;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 270;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 271;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else if((mostCurrent._v6).equals("up")) { 
 //BA.debugLineNum = 273;BA.debugLine="pDown.SetLayoutAnimated(500,pCamera.Left,pCame";
mostCurrent._pdown.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()+mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 274;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 275;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 276;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else if((mostCurrent._v6).equals("down")) { 
 //BA.debugLineNum = 278;BA.debugLine="pUp.SetLayoutAnimated(500,pCamera.Left,pCamera";
mostCurrent._pup.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()-mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 279;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 280;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 281;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 };
 };
 //BA.debugLineNum = 287;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 288;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 18;BA.debugLine="Private pCamera As Panel";
mostCurrent._pcamera = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Private distanciaMinima As Int = 70";
_v7 = (int) (70);
 //BA.debugLineNum = 20;BA.debugLine="Private pRight As Panel";
mostCurrent._pright = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Private xM1,xM2,yM1,yM2 As Float";
_v0 = 0f;
_vv1 = 0f;
_vv2 = 0f;
_vv3 = 0f;
 //BA.debugLineNum = 22;BA.debugLine="Private pLeft As Panel";
mostCurrent._pleft = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Private pDown As Panel";
mostCurrent._pdown = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Private pUp As Panel";
mostCurrent._pup = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Private LockMove As Boolean = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 26;BA.debugLine="Private MoveDirection As String";
mostCurrent._v6 = "";
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return "";
}
public static String  _pcamera_click() throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub pCamera_Click";
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _pcamera_touch(int _action,float _x,float _y) throws Exception{
float _deltamovex = 0f;
float _deltamovey = 0f;
 //BA.debugLineNum = 46;BA.debugLine="Sub pCamera_Touch (Action As Int, X As Float, Y As";
 //BA.debugLineNum = 47;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 50;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 51;BA.debugLine="xM1 = X";
_v0 = _x;
 //BA.debugLineNum = 52;BA.debugLine="yM1 = y";
_vv2 = _y;
 break; }
case 1: {
 //BA.debugLineNum = 55;BA.debugLine="xM2 = x";
_vv1 = _x;
 //BA.debugLineNum = 56;BA.debugLine="yM2 = y";
_vv3 = _y;
 //BA.debugLineNum = 57;BA.debugLine="Private deltaMoveX As Float = xM2 - xM1";
_deltamovex = (float) (_vv1-_v0);
 //BA.debugLineNum = 58;BA.debugLine="Private deltaMoveY As Float = yM2 - yM1";
_deltamovey = (float) (_vv3-_vv2);
 //BA.debugLineNum = 60;BA.debugLine="If Abs(deltaMoveX) > distanciaMinima Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_deltamovex)>_v7) { 
 //BA.debugLineNum = 61;BA.debugLine="If x > xM1 Then 'LEFT TO RIGHT";
if (_x>_v0) { 
 //BA.debugLineNum = 62;BA.debugLine="If LockMove = True And MoveDirection <> \"righ";
if (_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("right") == false) { 
if (true) return "";};
 //BA.debugLineNum = 63;BA.debugLine="LockMove = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 64;BA.debugLine="MoveDirection = \"right\"";
mostCurrent._v6 = "right";
 //BA.debugLineNum = 65;BA.debugLine="If Not(pLeft.Left >= 0%x) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._pleft.getLeft()>=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA))) { 
 //BA.debugLineNum = 66;BA.debugLine="pLeft.Left = pLeft.Left + 3%X";
mostCurrent._pleft.setLeft((int) (mostCurrent._pleft.getLeft()+anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (3),mostCurrent.activityBA)));
 };
 }else {
 //BA.debugLineNum = 69;BA.debugLine="If LockMove = True And MoveDirection <> \"left";
if (_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("left") == false) { 
if (true) return "";};
 //BA.debugLineNum = 70;BA.debugLine="LockMove = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 71;BA.debugLine="MoveDirection = \"left\"";
mostCurrent._v6 = "left";
 //BA.debugLineNum = 72;BA.debugLine="If Not(pRight.Left <= 0%x) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._pright.getLeft()<=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA))) { 
 //BA.debugLineNum = 73;BA.debugLine="pRight.Left = pRight.Left - 3%x";
mostCurrent._pright.setLeft((int) (mostCurrent._pright.getLeft()-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (3),mostCurrent.activityBA)));
 };
 };
 }else if(anywheresoftware.b4a.keywords.Common.Abs(_deltamovey)>_v7) { 
 //BA.debugLineNum = 77;BA.debugLine="If yM2 > yM1 Then 'TOP TO DOWN";
if (_vv3>_vv2) { 
 //BA.debugLineNum = 78;BA.debugLine="If LockMove = True And MoveDirection <> \"down";
if (_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("down") == false) { 
if (true) return "";};
 //BA.debugLineNum = 79;BA.debugLine="LockMove = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 80;BA.debugLine="MoveDirection = \"down\"";
mostCurrent._v6 = "down";
 //BA.debugLineNum = 81;BA.debugLine="If Not(pUp.Top >= 0%Y) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._pup.getTop()>=anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA))) { 
 //BA.debugLineNum = 82;BA.debugLine="pUp.Top = pUp.Top + 2%Y";
mostCurrent._pup.setTop((int) (mostCurrent._pup.getTop()+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (2),mostCurrent.activityBA)));
 };
 }else {
 //BA.debugLineNum = 85;BA.debugLine="If LockMove = True And MoveDirection <> \"up\"";
if (_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("up") == false) { 
if (true) return "";};
 //BA.debugLineNum = 86;BA.debugLine="LockMove = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 87;BA.debugLine="MoveDirection = \"up\"";
mostCurrent._v6 = "up";
 //BA.debugLineNum = 88;BA.debugLine="If Not(pDown.Top <= 0%Y) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._pdown.getTop()<=anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA))) { 
 //BA.debugLineNum = 89;BA.debugLine="pDown.Top = pDown.Top - 2%Y";
mostCurrent._pdown.setTop((int) (mostCurrent._pdown.getTop()-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (2),mostCurrent.activityBA)));
 };
 };
 };
 break; }
case 2: {
 //BA.debugLineNum = 97;BA.debugLine="If LockMove = True And MoveDirection = \"left\" T";
if (_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("left")) { 
 //BA.debugLineNum = 98;BA.debugLine="If pRight.Left <= 65%x Then";
if (mostCurrent._pright.getLeft()<=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 99;BA.debugLine="pRight.SetLayoutAnimated(500,pCamera.Left,pCa";
mostCurrent._pright.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 }else {
 //BA.debugLineNum = 101;BA.debugLine="pRight.SetLayoutAnimated(500,pCamera.Left + p";
mostCurrent._pright.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()+mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 102;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 103;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 };
 }else if(_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("right")) { 
 //BA.debugLineNum = 107;BA.debugLine="If pLeft.Left >= -65%x Then";
if (mostCurrent._pleft.getLeft()>=-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 108;BA.debugLine="pLeft.SetLayoutAnimated(500,pCamera.Left,pCam";
mostCurrent._pleft.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 }else {
 //BA.debugLineNum = 110;BA.debugLine="pLeft.SetLayoutAnimated(500,pCamera.Left - pC";
mostCurrent._pleft.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()-mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 111;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 112;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 };
 }else if(_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("up")) { 
 //BA.debugLineNum = 116;BA.debugLine="If pDown.Top <= 80%Y Then";
if (mostCurrent._pdown.getTop()<=anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (80),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 117;BA.debugLine="pDown.SetLayoutAnimated(500,pCamera.Left,pCam";
mostCurrent._pdown.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 }else {
 //BA.debugLineNum = 119;BA.debugLine="pDown.SetLayoutAnimated(500,pCamera.Left,pCam";
mostCurrent._pdown.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()+mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 120;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 121;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 };
 }else if(_v5==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._v6).equals("down")) { 
 //BA.debugLineNum = 125;BA.debugLine="If pUp.Top >= -80%Y Then";
if (mostCurrent._pup.getTop()>=-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (80),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 126;BA.debugLine="pUp.SetLayoutAnimated(500,pCamera.Left,pCamer";
mostCurrent._pup.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 }else {
 //BA.debugLineNum = 128;BA.debugLine="pUp.SetLayoutAnimated(500,pCamera.Left,pCamer";
mostCurrent._pup.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()-mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 129;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 130;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 };
 };
 break; }
}
;
 //BA.debugLineNum = 136;BA.debugLine="End Sub";
return "";
}
public static String  _pdown_touch(int _action,float _x,float _y) throws Exception{
float _deltamovey = 0f;
 //BA.debugLineNum = 195;BA.debugLine="Sub pDown_Touch (Action As Int, X As Float, Y As F";
 //BA.debugLineNum = 196;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 198;BA.debugLine="yM1 = y";
_vv2 = _y;
 break; }
case 1: {
 //BA.debugLineNum = 200;BA.debugLine="yM2 = y";
_vv3 = _y;
 //BA.debugLineNum = 201;BA.debugLine="Private deltaMovey As Float = yM2 - yM1";
_deltamovey = (float) (_vv3-_vv2);
 //BA.debugLineNum = 202;BA.debugLine="If Abs(deltaMovey) > distanciaMinima Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_deltamovey)>_v7) { 
 //BA.debugLineNum = 203;BA.debugLine="If y > yM1 Then 'UP TO DOWN";
if (_y>_vv2) { 
 //BA.debugLineNum = 204;BA.debugLine="pDown.Top = pDown.Top + 2%y";
mostCurrent._pdown.setTop((int) (mostCurrent._pdown.getTop()+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (2),mostCurrent.activityBA)));
 };
 };
 break; }
case 2: {
 //BA.debugLineNum = 208;BA.debugLine="If pDown.Top >= 30%x Then";
if (mostCurrent._pdown.getTop()>=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 209;BA.debugLine="pDown.SetLayoutAnimated(500,pCamera.Left,pCame";
mostCurrent._pdown.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()+mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 210;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 211;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 }else {
 //BA.debugLineNum = 213;BA.debugLine="pDown.SetLayoutAnimated(500,pCamera.Left,pCame";
mostCurrent._pdown.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 };
 break; }
}
;
 //BA.debugLineNum = 216;BA.debugLine="End Sub";
return "";
}
public static String  _pleft_touch(int _action,float _x,float _y) throws Exception{
float _deltamovex = 0f;
 //BA.debugLineNum = 170;BA.debugLine="Sub pLeft_Touch (Action As Int, X As Float, Y As F";
 //BA.debugLineNum = 171;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 173;BA.debugLine="xM1 = X";
_v0 = _x;
 break; }
case 1: {
 //BA.debugLineNum = 175;BA.debugLine="xM2 = x";
_vv1 = _x;
 //BA.debugLineNum = 176;BA.debugLine="Private deltaMoveX As Float = xM2 - xM1";
_deltamovex = (float) (_vv1-_v0);
 //BA.debugLineNum = 177;BA.debugLine="If Abs(deltaMoveX) > distanciaMinima Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_deltamovex)>_v7) { 
 //BA.debugLineNum = 178;BA.debugLine="If x < xM1 Then 'RIGHT TO LEFT";
if (_x<_v0) { 
 //BA.debugLineNum = 179;BA.debugLine="pLeft.Left = pLeft.Left - 3%x";
mostCurrent._pleft.setLeft((int) (mostCurrent._pleft.getLeft()-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (3),mostCurrent.activityBA)));
 };
 };
 break; }
case 2: {
 //BA.debugLineNum = 183;BA.debugLine="If pLeft.Left <= -30%x Then";
if (mostCurrent._pleft.getLeft()<=-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 184;BA.debugLine="pLeft.SetLayoutAnimated(500,pCamera.Left - pCa";
mostCurrent._pleft.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()-mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 185;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 186;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 }else {
 //BA.debugLineNum = 188;BA.debugLine="pLeft.SetLayoutAnimated(500,pCamera.Left,pCame";
mostCurrent._pleft.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 };
 break; }
}
;
 //BA.debugLineNum = 191;BA.debugLine="End Sub";
return "";
}
public static String  _pright_touch(int _action,float _x,float _y) throws Exception{
float _deltamovex = 0f;
 //BA.debugLineNum = 145;BA.debugLine="Sub pRight_Touch (Action As Int, X As Float, Y As";
 //BA.debugLineNum = 146;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 148;BA.debugLine="xM1 = X";
_v0 = _x;
 break; }
case 1: {
 //BA.debugLineNum = 150;BA.debugLine="xM2 = x";
_vv1 = _x;
 //BA.debugLineNum = 151;BA.debugLine="Private deltaMoveX As Float = xM2 - xM1";
_deltamovex = (float) (_vv1-_v0);
 //BA.debugLineNum = 152;BA.debugLine="If Abs(deltaMoveX) > distanciaMinima Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_deltamovex)>_v7) { 
 //BA.debugLineNum = 153;BA.debugLine="If x > xM1 Then 'LEFT TO RIGHT";
if (_x>_v0) { 
 //BA.debugLineNum = 154;BA.debugLine="pRight.Left = pRight.Left + 3%x";
mostCurrent._pright.setLeft((int) (mostCurrent._pright.getLeft()+anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (3),mostCurrent.activityBA)));
 };
 };
 break; }
case 2: {
 //BA.debugLineNum = 158;BA.debugLine="If pRight.Left >= 30%x Then";
if (mostCurrent._pright.getLeft()>=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 159;BA.debugLine="pRight.SetLayoutAnimated(500,pCamera.Left + pC";
mostCurrent._pright.SetLayoutAnimated((int) (500),(int) (mostCurrent._pcamera.getLeft()+mostCurrent._pcamera.getWidth()),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 160;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 161;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 }else {
 //BA.debugLineNum = 163;BA.debugLine="pRight.SetLayoutAnimated(500,pCamera.Left,pCam";
mostCurrent._pright.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 };
 break; }
}
;
 //BA.debugLineNum = 166;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 14;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _pup_touch(int _action,float _x,float _y) throws Exception{
float _deltamovey = 0f;
 //BA.debugLineNum = 224;BA.debugLine="Sub pUp_Touch (Action As Int, X As Float, Y As Flo";
 //BA.debugLineNum = 225;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 227;BA.debugLine="yM1 = y";
_vv2 = _y;
 break; }
case 1: {
 //BA.debugLineNum = 229;BA.debugLine="yM2 = y";
_vv3 = _y;
 //BA.debugLineNum = 230;BA.debugLine="Private deltaMovey As Float = yM2 - yM1";
_deltamovey = (float) (_vv3-_vv2);
 //BA.debugLineNum = 231;BA.debugLine="If Abs(deltaMovey) > distanciaMinima Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_deltamovey)>_v7) { 
 //BA.debugLineNum = 232;BA.debugLine="If y < yM1 Then 'UP TO DOWN";
if (_y<_vv2) { 
 //BA.debugLineNum = 233;BA.debugLine="pUp.Top = pUp.Top - 2%y";
mostCurrent._pup.setTop((int) (mostCurrent._pup.getTop()-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (2),mostCurrent.activityBA)));
 };
 };
 break; }
case 2: {
 //BA.debugLineNum = 237;BA.debugLine="If pUp.Top <= -30%x Then";
if (mostCurrent._pup.getTop()<=-anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 238;BA.debugLine="pUp.SetLayoutAnimated(500,pCamera.Left,pCamera";
mostCurrent._pup.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),(int) (mostCurrent._pcamera.getTop()-mostCurrent._pcamera.getHeight()),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 //BA.debugLineNum = 239;BA.debugLine="MoveDirection = \"none\"";
mostCurrent._v6 = "none";
 //BA.debugLineNum = 240;BA.debugLine="LockMove = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 }else {
 //BA.debugLineNum = 242;BA.debugLine="pUp.SetLayoutAnimated(500,pCamera.Left,pCamera";
mostCurrent._pup.SetLayoutAnimated((int) (500),mostCurrent._pcamera.getLeft(),mostCurrent._pcamera.getTop(),mostCurrent._pcamera.getWidth(),mostCurrent._pcamera.getHeight());
 };
 break; }
}
;
 //BA.debugLineNum = 245;BA.debugLine="End Sub";
return "";
}
}
